
* __SPISAK_APPBROWSER.PRG

  /*
    20-04-2008 COBA Systems  Stanojevi S.

    GUI-CRT appbrowse komanda korisnikog menija, za kontrolu DBEDIT TABELE
    inplementirana je i demonstrirana je u tehnikama i funkcijama ovog PRG modula

  */


  #include "XBTSYS.CH"  // zbog upotrebe funkcija iz XbToolsIII alata
  #include "Box.ch"
  #include "Fileio.ch"
  #include "Appevent.ch"
  #include "Xbp.ch"
  #include "Gra.ch"
  #include "Font.ch"
  #include "color.ch"
  #include "common.ch"
  #include "inkey.ch"
  #include "set.ch"
  #include "Directry.ch"

                          // Zbog AppBrowse/AppDisplay/AppEdit
  #include "Appbrow.ch"   // mora da postoji na pocetku PRG modula ili funkcije
  MEMVAR appObject        // mora da se postavi samo jednom na pocetku PRG modula




* FUNCTION Nadji_DeoReci1()
* STATIC FUNCTION KeyHandler( nKey, oBj )
* FUNCTiON Nadji_DeoReci2()
* FUNCTION deo_naziva(cString,Naziv)  // Poziva se iz AppBrowse i ne sme da bude STATIC



***************************************************************************************
// Varijanta AppBrowser - sa prozorom kontejnerom
FUNCTION Nadji_DeoReci1() // formiranje AppBrowse/AppDisplay Liste SKUPA artikala
***************************************************************************************
   LOCAL nEvent, mp1, mp2, oXbp, lExit := .F.
   LOCAL oDlg, drawingArea, oBtn, aPos, aSize, oFocus, x := 260, y := 340

 //  DEFAULT cTitle TO "Izaberi stavku:"
   SET CHARSET TO ANSI
   ********************************************
   cString := c_zadaj("Upii deo naziva","",13)
   ********************************************
   aSize := { x, y }
   aPos  := CenterPos( aSize, AppDesktop():currentSize() )

   oDlg := XbpDialog():new( AppDesktop(), SetAppWindow(), aPos, aSize, , .F.)
   oDlg:taskList := .T.
   //oDlg:SysMenu  := .F.
   oDlg:MinButton  := .F.
   oDlg:MaxButton  := .F.
   oDlg:title    := "Skup traenih vrednosti"
   // Ovo nije potrebno i ne radi jer AppBrowser u potpunosti preuzima komandu i daje izlaz samo sa Esc:
   // oDlg:keyboard := {|nKey,mp2,obj| KeyHandler( nKey, obj) }  // FUNCTION KeyHandler( nKey, obj)
    oDlg:create()
   oDlg:Close    := { || lExit := .T. }

   drawingArea := oDlg:drawingArea
   drawingArea:setFontCompoundName( "8.Helv" )

   oXbp := XbpStatic():new( drawingArea, , {10,250}, {216,48} )
   oXbp:caption := "Izaberi sa kursorskom strelicom na gore ili na dole i pritisni taster (Esc) ili miem dugme (OK)"
   oXbp:options := XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_CENTER+XBPSTATIC_TEXT_WORDBREAK
   oXbp:create()
  /*
   * The pushbutton reacts to the Return and Esc keys due to
   * the :keyboard code block
   */
   oBtn := XbpPushButton():new( drawingArea, , {86,12}, {67,24} )
   oBtn:caption  := "OK"
   oBtn:activate := {|| lExit := .T. }
//   oBtn:keyboard := {|nKey| IIF( nKey == xbeK_RETURN .OR. nKey == xbeK_ESC, ;
//                                 lExit := .T., NIL ) }
   oBtn:setPointer(NIL,2)
   oBtn:create()

   oDlg:show()
   oDlg:setModalState( XBP_DISP_APPMODAL )
  //-------------------------------------------------------------------------------------------
    PRIVATE radno := SELECT() , rek := RecNo()

  // cString := c_zadaj("Upii deo naziva","",13)

    SET ORDER TO 1     // UREDI PO NAZIVU I PRIKAI BROWSER LISTU ARTIKALA
    GO TOP

      APPBROWSE ;                                       // Define browser
         POSITION CENTER, CENTER FONT "8.Courier New" ; // PARENT SetAppWindow()
         TITLE "IFARNIK robe" SIZE {x-10, y-110}  COLOR GRA_CLR_DARKRED, GRA_CLR_YELLOW ;
         PARENT oDlg ;
         FOR deo_naziva(cString, ROBN_)  // prikazi samo robu koja ima --> .T.

      * APPFIELD nVar := Recno()  CAPTION  "Record number" // Define fields

        APPFIELD ROBS_     CAPTION "ifra"         //COLOR GRA_CLR_RED
        APPFIELD ROBN_     CAPTION "NAZIV ARTIKLA" COLOR GRA_CLR_WHITE, GRA_CLR_DARKRED
        APPFIELD DOBK_     CAPTION "KATALOKI BROJ"
        APPFIELD CENA_     CAPTION "CENA"
        APPFIELD ZALI_     CAPTION "ZALIHE"
        APPFIELD MERA_     CAPTION "JMR"
        APPFIELD PPUP_     CAPTION "PDV"

      APPDISPLAY        // Display browser modal
                        // prikaz browsera i izbor stavke iz liste browsera

      appObject:keyboard := {|nKey| IIF( nKey == xbeK_ENTER .OR. nKey == xbeK_ESC, ;
                            lExit := .T., NIL ) }
      sif := ROBS_          // pre izlaska iz browsera preuzmi ifru artikla
      // msgbox(sif,"ifra")
      SET ORDER TO 2 // UREDI SPISAK PO IFRI
      GO TOP
      SEEK sif
      IF FOUND()
        // OK
        // MsgBox("Naao sam")
      ELSE
        GOTO rek
        // MsgBox("Nisam Naao")
      ENDIF
      SELECT(radno)
   //-------------------------------------------------------------------------------------------
   // ne setuj fokus, jer AppBrowse komanda setuje svoj fokus i ne dozvoljava drugi
   // oFocus := SetAppFocus( oBtn )
   // oFocus := SetAppFocus( oDlg )
   DO WHILE ! lExit
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO
   oDlg:setModalState( XBP_DISP_MODELESS )
   oDlg:destroy()
   tone(2000)
   //SetAppFocus( oFocus )
RETURN nil
*****************************************************************
STATIC FUNCTION KeyHandler( nKey, oBj )
*****************************************************************
   DO CASE
   CASE nKey == xbeK_ESC
      // msgbox("Esc")
      PostAppEvent( xbeP_Close,,, oBj:setParent():setParent() )
   CASE nKey == xbeK_RETURN
      //msgbox("Enter")
      PostAppEvent( xbeP_Activate,,, oBj )
   ENDCASE

RETURN nil



******************************************************************************************************
// varijanta AppBrowser - bez prozora kontejnera
FUNCTiON Nadji_DeoReci2()  // formiranje AppBrowse/AppDisplay Liste SKUPA artikala

******************************************************************************************************
/*
 Na startu PRG modula:
  bBlockDeo  := SetKey( K_F3, {|| NadjiDeoReci2() }  )
        * kod PRG modula...
 na kraju PRG modula:
  SetKey( K_F3, bBlockDeo  )
*/


LOCAL radno := SELECT() , rek := RecNo()

  cString := c_zadaj("Upii deo naziva","",13)

    SET ORDER TO 1     // UREDI PO NAZIVU I PRIKAI BROWSER LISTU ARTIKALA
    GO TOP

//      APPBROWSE ;                                   // Define browser
//         POSITION TOP, RIGHT FONT "8.Courier New" ; // PARENT SetAppWindow()
//         TITLE "IFARNIK robe" SIZE  40, 42 PERCENT COLOR GRA_CLR_DARKRED, GRA_CLR_YELLOW ;
//         FOR deo_naziva(cString,ROBN_)  // prikazi samo robu koja ima --> .T.

      APPBROWSE INTO appObject;                                   // Define browser
         POSITION CENTER, CENTER FONT "8.Courier New" ; // PARENT SetAppWindow()
         TITLE "IZABERI pa izlaz sa (Esc)" SIZE  {250,230} COLOR GRA_CLR_DARKRED, GRA_CLR_YELLOW ;
         FOR deo_naziva(cString,ROBN_)  // prikazi samo robu koja ima --> .T.


      * APPFIELD nVar := Recno()  CAPTION  "Record number" // Define fields

        APPFIELD ROBS_     CAPTION "ifra"         //COLOR GRA_CLR_RED
        APPFIELD ROBN_     CAPTION "NAZIV ARTIKLA" COLOR GRA_CLR_WHITE, GRA_CLR_DARKRED
        APPFIELD DOBK_     CAPTION "KATALOKI BROJ"
        APPFIELD CENA_     CAPTION "CENA"
        APPFIELD ZALI_     CAPTION "ZALIHE"
        APPFIELD MERA_     CAPTION "JMR"
        APPFIELD PPUP_     CAPTION "PDV"


      APPDISPLAY        // Display browser modal
                        // prikaz browsera i izbor stavke iz liste browsera



  sif := ROBS_          // pre izlaska iz browsera preuzmi ifru artikla

  // msgbox(sif,"ifra")


  SET ORDER TO 2 // UREDI SPISAK PO IFRI
  GO TOP

  SEEK sif
  IF FOUND()
    // OK
    // MsgBox("Naao sam")
  ELSE
    GOTO rek
    // MsgBox("Nisam Naao")
  ENDIF

  SELECT(radno)
RETURN nil

******************************************
FUNCTION deo_naziva(cString,Naziv)
******************************************
LOCAL ima
DEFAULT Naziv TO "*"

ima := AT(cString,Naziv)
IF ima = 0
   RETURN(.F.)
ELSE
   RETURN(.T.)
ENDIF
RETURN(.F.)



// CenterPos( aSize, aRefSize )
// Standardna Xbase++ funkcija za centriranje prozora
// sa dimenzijama na primer: aSize := {300,400}
// u drugom prozoru na primer: oParent := AppDesktop()
// aPos := CenterPos( aSize, oParent:currentSize() )
// gde je aPos := {x,y} pozicija pocetka prozora
***********************************************
STATIC FUNCTION CenterPos( aSize, aRefSize )
***********************************************
RETURN { Int( (aRefSize[1] - aSize[1]) / 2 ) ;
       , Int( (aRefSize[2] - aSize[2]) / 2 ) }
