
* __SPISAK_ARTIKALA.PRG

  /*
    20-04-2008 COBA Systems  Stanojevi S.

    Nova tehnologija GUI-CRT DBEDIT korisnikog menija, za kontrolu DBEDIT TABELE
    inplementirana je i demonstrirana je u tehnikama i funkcijama ovog PRG modula

  */


  #include "XBTSYS.CH"  // zbog upotrebe funkcija iz XbToolsIII alata
  #include "Box.ch"
  #include "Fileio.ch"
  #include "Appevent.ch"
  #include "Xbp.ch"
  #include "Gra.ch"
  #include "Font.ch"
  #include "color.ch"
  #include "common.ch"
  #include "inkey.ch"
  #include "set.ch"
  #include "Directry.ch"
                           // Zbog AppBrowse/AppDisplay/AppEdit
 * #include "Appbrow.ch"   // mora da postoji na pocetku PRG modula ili funkcije
 * MEMVAR appObject        // mora da se postavi samo jednom na pocetku PRG modula
********************************************************************************************

PROCEDURE _SPISAK_ARTIKALA()

********************************************************************************************
* Spisak robe u objektu - u prodavnici i magacinu



 LOCAL radno := SELECT()

 SET COLOR TO /W
 CLEAR SCREEN

 SET SCOREBOARD OFF
 SET CONFIRM ON
 SET ESCAPE ON
 SET DATE GERMAN
 SET CENTURY ON


  PRIVATE boja := setcolor() , prozor := space(10)
  PAPIR("SPISAK ARTIKALA",1)

  SET COLOR TO R+/W
  @ 01,02 say REPLICATE(CHR(196),66) + "ROBA.DBF"

  SETCOLOR(boja)
  save screen to prozor

  PRIVATE g_red,g_kol,d_red,d_kol, g_lin, d_lin, KFUNK, DBE
  PRIVATE polje, upis, naslov, podela, poruka


      USE ROBA.DBF NEW EXCLUSIVE ALIAS "ROBA"
      IF neterr()
         MsgBox("Zauzeto u mrei","STOP")
         RETURN
      ENDIF
      INDEX ON ROBS_ TO ROBA_S.NTX   // po ifri artikla
      INDEX ON ROBN_ TO ROBA_N.NTX   // po nazivu artikla
      INDEX ON DOBK_ TO ROBA_K.NTX   // po katalokom broju artikla

      SET INDEX TO ROBA_N, ROBA_S, ROBA_K

  GO TOP

  *****************
  g_red=02
  g_kol=01
  d_red=14
  d_kol=78
  *****************
  declare polje[7]
  polje[1] ="ROBS_"
  polje[2] ="ROBN_"
  polje[3] ="MERA_"
  polje[4] ="ZALI_"
  polje[5] ="CENA_"
  polje[6] ="PPUP_"  // POREZ%
  polje[7] ="DOBK_"  // KATALOSKI BROJ
  ****************
  declare upis[7]
  upis[1] ="@X"
  upis[2] ="@X"
  upis[3] ="@X"
  upis[4] ="@9"
  upis[5] ="@9"
  upis[6] ="@9"
  upis[7] ="@X"
  ***************
  declare naslov[7]
  naslov[1] =  "SIFRA"
  naslov[2] =  "NAZIV Artikla"
  naslov[3] =  "JMR"
  naslov[4] =  "ZALIHE U OBJEKTU"
  naslov[5] =  "CENA"
  naslov[6] =  "PDV"
  naslov[7] =  "KATALOSKI BROJ"
  ***************
  g_lin=""
  declare podela[7]
  afill(podela,"")
  d_lin=" "
  keyboard " "
  **************************************
  kfunk := "DBEDIT_Korisnicka_Funkcija"
  **************************************
  /*
    20-04-2008 COBA Systems  Stanojevi S.

    Nova tehnologija GUI-CRT DBEDIT korisnikog menija
    inplementirana je u tehnikama i funkcijama:

  */

                              oMenuBar:disable() // iskljui glavni windows meni
                              Meni_create()      // kreiraj GUI meni
                              setappfocus(setappwindow())

   SET KEY 28 TO help_F1()
   @ g_red,g_kol TO d_red+1,d_kol
   SET COLOR TO W/,R/W,W+/R
   ************************************************************************************
    DBE := dbedit(g_red+1,g_kol+1,d_red,d_kol-1,polje,kfunk,upis,naslov,g_lin,podela)
   ************************************************************************************
   CLOSE DATABASES
   setcolor(boja)
   restore screen from prozor
   release prozor
   SET KEY 28 TO
                              Meni_destroy()    // obrii GUI meni
                              oMenuBar:enable() // ukljui glavni windows meni



RETURN










*************************************
FUNCTION DBEDIT_Korisnicka_Funkcija
*************************************
parameters mod,imepolja      && S,F
private ulazpolja,prozor,r,k,w,boja
ulazpolja=polje[imepolja]
boja=setcolor()
set cursor off
*
r=row()
k=col()
*

  broj_art=reccount()
  SET COLOR TO R/W
  @ 02,02 say REPLICATE(CHR(196),67)
  @ 02,02 say ROBS_+" "+ALLTRIM(ROBN_)+" "+ALLTRIM(DOBK_)
  SET COLOR TO R+/W
  @ 02,66 say "Ukupno "+alltrim(str(broj_art))  //VAR2CHAR(W)//
  SETCOLOR(boja)


 w := LASTKEY()

if broj_art=0

     nn = alert("SPISAK JE PRAZAN",{"Otvori sifru","Izlaz"})
     IF nn=1
        w := 22      // OTVARANJE NOVE SIFRE ARTIKLA
     ELSE
        RETURN(0)    // PREKID PROGRAMA
     ENDIF

endif






*---------------------------(Esc)-----------------------------
IF W=27
     RETURN(0)  // IZLAZ IZ PROGRAMA
ENDIF



 IF W = 22  // insert
  **************
    Roba1_INS()     // dodaj novi artikal na spisak
  **************
  set cursor off
   keyboard " "
   RETURN(2)
 ENDIF


 IF W = 7  // delete
  ***************
   Roba1_DEL()       // obrii artikal sa spiska
  ***************
  set cursor off
   keyboard " "
   RETURN(2)
 ENDIF


 IF W = 9  // Tab
  ****************
   Meni_destroy()
   Roba1_TAB()       // edituj - obradi karticu artikla
   Meni_create()
  ****************
   keyboard " "
   RETURN(2)
 ENDIF


 IF chr(w)$"Xx"
  ******************
  * Trazi_DeoReci2() // ili ovaj prostiji sistem
    Nadji_DeoReci1() // ili ovaj efektniji sistem
  ******************
   keyboard " "
   RETURN(2)
 ENDIF


 IF chr(w)$"Uu"
   ****************
    help_U()         // uputstvo
   ****************
   keyboard " "
   RETURN(2)
 ENDIF



*---------------------------(Enter)---------------------------
IF W = 13

  IF ulazpolja == "ROBS_"

     // NIJE DOZVOLJENA IZMENA IFRE !!!

  ELSE


   SET CURSOR ON
   SET COLOR TO W/N,W+/R
   @ r,k GET &ulazpolja
   tone(50)
   READ
   CLEAR GETS
   SETCOLOR(boja)
   keyboard " "
   RETURN(2)

  ENDIF  // IF ulazpolja <> "ROBS_"

  keyboard " "
  RETURN(2)

ENDIF



*------------------- nadji po sifri (S)----------------------
if chr(w)$"sS"
  ************
    Rob1_sif()
  ************
   KEYBOARD " "
   RETURN(2)
endif

*------------------- nadji po nazivu (N)--------------------
if chr(w)$"nN"
  ***********
   Rob1_naz()
  ***********
   KEYBOARD " "
   RETURN(2)
endif


*------------------- nadji po katal.broju (K)--------------------
if chr(w)$"kK"
  ***********
   Rob1_kat()
  ***********
   KEYBOARD " "
   RETURN(2)
endif

*------------------- prikaz stanja zaliha (Zz)--------------------
if chr(w)$"zZ"
  ***********
   Stanje_Zaliha(0)   // stanje zaliha
  ***********
   KEYBOARD " "
   RETURN(2)
endif

*------------------- upisi cenu i kolicinu (Cc)--------------------
if chr(w)$"cC"
  ***********
   Rob1_cen()
  ***********
   KEYBOARD " "
   RETURN(2)
endif



RETURN(1)


























/*
  20-04-2008 COBA Systems  Stanojevi S.

  Nova tehnologija GUI-CRT DBEDIT korisnikog menija
  inplementirana je u funkcijama:

  FUNCTION Meni_create()
  FUNCTION pozovi_broj(chrkod)
  FUNCTION pozovi_slovo(asckod)
  FUNCTION Meni_destroy()

  Ovde je vano znati:

  1. Ne sme se u GUI XbpPushbutton objektu direktno pozivati funkcija i procedura
     ije pozivanje je programirano u korisnikoj funkciji za DBEDIT() funkciju:

                          FUNCTION DBEDIT_Korisnicka_Funkcija()

     na primer:

     funkcija:
                 Trazi_DeoReci()

     mora se pozvati kao slovo "D" preko funkcije

                 pozovi_slovo()

     jer se ona iz DBEDIT() funkcije poziva sa tasterom slovo "D"

     Dakle, ne sme se pisati:

                 oPushButton:activate := {|| Trazi_DeoReci() }
     ve:
                 oPushButton:activate := {|| pozovi_slovo("D") }

     ime se u stvari izvrava korisnika funkcija:

                 FUNCTION DBEDIT_Korisnicka_Funkcija()

     jer e samo na ovaj nain posle izvrenja ove funkcije doi do ispravnog
     osveavanja i ponovnog aktiviranja DBEDIT browsera. U protivnom ima puno
     problema sa radom aplikacije.



     Takoe, funkcija:

                 Roba1_TAB()

     mora se pozvati kao kod numerik 9 preko funkcije

                 pozovi_broj()

     jer se ona iz DBEDIT() funkcije poziva sa tasterom TAB iji CHR kod je 9

     Dakle, ne sme se pisati:

                 oPushButton:activate := {|| Roba1_TAB() }
     ve:
                 oPushButton:activate := {|| pozovi_broj(9) }

     ime se u stvari izvrava korisnika funkcija:

                 FUNCTION DBEDIT_Korisnicka_Funkcija()

     jer e samo na ovaj nain posle izvrenja ove funkcije doi do ispravnog
     osveavanja i ponovnog aktiviranja DBEDIT browsera. U protivnom ima puno
     problema sa radom aplikacije.

*/

******************************************************************************
FUNCTION Meni_create()
******************************************************************************
PRIVATE boja
boja=setcolor()


    PUBLIC T_04,T_05,T_08,T_09,T_00

     // INSERT dodaj artikal
      T_04:= XbpPushButton():new()
      T_04:caption := "(Ins) Dodaj"
      T_04:preselect := .T.
      T_04:create( , , {10,114}, {120,28} )

      T_04:activate := {|| pozovi_broj(22)  }
      T_04:setFontCompoundName( "8.Helv Bold" )
      T_04:setpointer(nil,2)

     // DELETE obrii artikal
      T_05:= XbpPushButton():new()
      T_05:caption := "(Del) Obrii"
      T_05:preselect := .T.
      T_05:create( , , {130,114}, {120,28} )

      T_05:activate := {|| pozovi_broj(7)  }
      T_05:setFontCompoundName( "8.Helv Bold" )
      T_05:setpointer(nil,2)

     // TAB edituj karticu artikla
      T_08:= XbpPushButton():new()
      T_08:caption := "(Tab) Upii"
      T_08:preselect := .T.
      T_08:create( , , {250,114}, {120,28} )

      T_08:activate := {|| pozovi_broj(9) }
      T_08:setFontCompoundName( "8.Helv Bold" )
      T_08:setpointer(nil,2)


     // F2 suma
      T_09:= XbpPushButton():new()
      T_09:caption := "(X) Trai"
      T_09:preselect := .T.
      T_09:create( , , {370,114}, {120,28} )

      T_09:activate := {|| pozovi_slovo("X")  }
      T_09:setFontCompoundName( "8.Helv Bold" )
      T_09:setpointer(nil,2)

     // SLOBODNO
      T_00:= XbpPushButton():new()
      T_00:caption := "(U) Uputstvo"
      T_00:preselect := .T.
      T_00:create( , , {510,114}, {120,28} )

      T_00:activate := {|| pozovi_slovo("U")  }
      T_00:setFontCompoundName( "8.Helv Bold" )
      T_00:setpointer(nil,2)

      SetAppFocus(SetAppWindow())
      KEYBOARD CHR(19)+CHR(29)

RETURN nil

*****************************
FUNCTION pozovi_broj(chrkod)
*****************************
 KEYBOARD CHR(chrkod)
RETURN nil

*****************************
FUNCTION pozovi_slovo(asckod)
*****************************
 chrkod := ASC(asckod)
 KEYBOARD CHR(chrkod)
RETURN nil


***************************
FUNCTION Meni_destroy()
***************************

     T_04:DESTROY()
     T_05:DESTROY()
     T_08:DESTROY()
     T_09:DESTROY()
     T_00:DESTROY()

   RELEASE T_04,T_05,T_08,T_09,T_00

RETURN nil


























******************************************************************************
FUNCTION Roba1_DEL()
PRIVATE naziv,radno,pomocno,sifra,rekord
naziv=ROBN_
sifra=ROBS_
    izb := ALERT("BRISANJE "+ROBS_, {"Dalje","Stop"})
         IF izb = 2
            RETURN(0)
         ENDIF
DELETE
PACK
COMMIT
GO TOP
MsgBox(naziv,"OBRISANO")
RETURN(0)
******************************************************************************
FUNCTION Roba1_TAB()
PRIVATE sifra,prozor,boja,radno
sifra=ROBS_
boja=setcolor()
prozor=space(10)
   save screen to prozor
   Rob_txt()
   Rob_get()
   Rob_say()
   inkey(0)
   restore screen from prozor
   release prozor
RETURN(0)
******************************************************************************
FUNCTION Roba1_INS()
PRIVATE sifra_stara,sifra,prozor,boja,rek
boja=setcolor()
prozor=space(10)
rek=RECNO()

SET ORDER TO 2
SET CURSOR ON
sifra=ZADAJ("NOVA SIFRA --> ",5,"S")
sifra=STRZERO(VAL(sifra),5)
SET CURSOR OFF

SEEK sifra
if found()
   MsgBox("ifra "+sifra+" postoji","STOP")
   rek=RECNO()
else
   APPEND BLANK
   REPLACE ROBS_ WITH sifra
   Roba1_TAB()
   rek=RECNO()
endif
tone(400,1)
GO TOP
GOTO rek
RETURN(0)
******************************************************************************
FUNCTION Rob1_sif
PRIVATE sifra
*
SET CURSOR ON
sifra=ZADAJ("SIFRA -> ",5,"S")
sifra=STRZERO(VAL(sifra),5)
SET CURSOR OFF
SET ORDER TO 2
GO TOP
LOCATE FOR ROBS_ = sifra
   if eof() = .f.
      TONE(500,1)
   else
      GO TOP
      MsgBox("ifra "+sifra+" nije naena","STOP")
   endif
RETURN(0)
******************************************************************************
FUNCTION Rob1_naz
PRIVATE naziv
SET CURSOR ON
naziv=ZADAJ("NAZIV -> ",25,"S")
naziv=ALLTRIM(naziv)
SET CURSOR OFF
*
duz=LEN(naziv)
SET ORDER TO 1
GO TOP
LOCATE FOR SUBSTR(ROBN_,1,duz) = naziv
   if eof() = .F.
      TONE(500,1)
   else
      GO TOP
      MsgBox("Naziv "+naziv+" nije naen","STOP")
   endif
RETURN(0)
******************************************************************************
FUNCTION Rob1_kat
PRIVATE naziv, rek := RECNO()
SET CURSOR ON
naziv=ZADAJ("KATALOSKI BROJ -> ",25,"S")
naziv=ALLTRIM(naziv)
SET CURSOR OFF
*
duz=LEN(naziv)

SET ORDER TO 3
GO TOP
LOCATE FOR SUBSTR(DOBK_,1,duz) = naziv
   if eof() = .F.
      TONE(500,1)
   else
      GOTO rek
      MsgBox("Kataloki broj "+naziv+" nije naen","STOP")
   endif
SET ORDER TO 1
RETURN(0)
******************************************************************************



******************************************************************************
FUNCTION Trazi_DeoReci()
PRIVATE REK,nadjeno,proz,boja,slova
boja=SETCOLOR()


    REK=RECNO()
    nadjeno=.T.
    SAVE SCREEN TO proz

    set color to N/W,W+/R
    @ 11,54 clear to 13,70
    @ 11,54 to 13,70 double

     set cursor on
     @ 11,56 say "Trazi DeoReci"
     slova=space(13)
     @ 12,56 GET slova
     read
     clear gets

         nadjeno := .F.
         rezultat := 0
         izb := 1

         slova := UPPER(alltrim(slova))
         SET ORDER TO 2       // SPISAK_ROBE_NAZIV
         // GO TOP            // ne diraj neka se nastavlja tamo gde stane
         DO WHILE .NOT. EOF()

            ROBN := UPPER(ALLTRIM(ROBN_))
            rezultat := AT(slova,ROBN)
           //-----------------------------------------------------------
            IF rezultat > 0  // nadjeno

               nadjeno := .T.

                 // prikazi naziv robe
               izb := ALERT(ROBS_+" - "+ALLTRIM(ROBN_), {"Dalje","Stop"})
                    IF izb = 2      // izlaz sa OK, ili nastavak listanja
                       KEYBOARD CHR(19)+CHR(4)
                       EXIT
                    ENDIF
            ENDIF
           //-----------------------------------------------------------
         SKIP
         ENDDO


         IF izb = 1  // samo ako izbor nije: "OK"

            IF nadjeno=.F.

               ALERT("Nema "+SUBSTR(slova,1,12)+"...")
               GOTO REK

            ELSE

               ALERT("KRAJ "+SUBSTR(slova,1,12)+"...")
               GOTO REK

            ENDIF

         ELSE   // ako je izbor = "OK" tada skoci na izabrani slog - sifru
                // izabrani slog je vec aktivan u tabeli - spisku robe
         ENDIF



    KEYBOARD CHR(19)+CHR(4)
    SETCOLOR(boja)
    RESTORE SCREEN FROM proz
    RELEASE proz

RETURN(0)

******************************************************************************
PROCEDURE help_U()

LOCAL cr := CHR(13)+CHR(10)
 MsgBox( ;
  "OSTALI TASTERI (command buttons)      "+cr+;
  "                                      "+cr+;
  "S - trai artikal po ifri            "+cr+;
  "N - trai artikal po nazivu           "+cr+;
  "K - trai artikal po kataokom broju  "+cr+;
  "X - trai artikal po rei u nazivu    "+cr+;
  "Z - trai pregled stanja zaliha       "+cr+;
  "C - Upii CENU i KOLIINU             "+cr+;
  "U - Uputstvo za rad                   "+cr+;
  "Enter - Upis podataka u izabrano polje"+cr+;
  "        Stani u kolonu tabele u polje" +cr+;
  "        i pritisni Enter, upii podatak"+cr+;
  "        i pritisni Enter.              "+cr+;
  "F1  - HELP                              "+cr+;
  "Esc - KRAJ                              "+cr+;
  " ","U P U T S T V O")
RETURN
PROCEDURE help_F1()
LOCAL cr := CHR(13)+CHR(10)
 MsgBox( ;
  "Help tekst koji se dobija sa tasterom F1"+cr+;
  "iz bilo koje operacije/situacije u aplikaciji."    +cr+;
  " ","H E L P")
RETURN
******************************************************************************


******************************
FUNCTION Rob_TXT
******************************
PRIVATE boja
boja=SETCOLOR()
SET COLOR TO N/W,R/W

@  1, 19 clear to 12,59

@  1, 19  TO 12, 59 double
SET COLOR TO R/W
@  2, 25  SAY "STAVKA - KARTICA ARTIKLA: "+ROBS_
SET COLOR TO N/W,R/W
@  3, 20  say replicate("",39)

@  5, 21  SAY "Naziv:"
@  7, 21  SAY "Jed.mere:"
@  9, 21  SAY "Stopa pp:"
@  9, 40  SAY "% (zbirna)"
@ 11, 21  SAY "KatalogBroj:"
SETCOLOR(boja)
RETURN(0)

******************************
FUNCTION Rob_SAY
******************************
PRIVATE boja
boja=SETCOLOR()
SET COLOR TO R/W,R/W
@ 5, 33  SAY  ROBN_
@ 7, 33  SAY  MERA_
@ 9, 33  SAY  PPUP_
@ 11,33  SAY DOBK_
SETCOLOR(boja)
RETURN(0)

******************************
FUNCTION Rob_GET
******************************
PRIVATE boja
boja=SETCOLOR()
SET COLOR TO N+/W,W+/R
TONE(500,1)
set cursor on
SETCURSOR(3)
@  5, 33  GET  ROBN_
@  7, 33  GET  MERA_
@  9, 33  GET  PPUP_
@ 11, 33  GET  DOBK_
READ
CLEAR GETS

IF UPDATED()=.T.
   // OK
ENDIF
COMMIT
set cursor off
SETCOLOR(boja)
RETURN(0)

******************************
FUNCTION Rob1_CEN
******************************
PRIVATE boja, prozor
boja=SETCOLOR()
SET COLOR TO N/W,R/W
SAVE SCREEN TO prozor

@  1, 19 clear to 10,59
@  1, 19  TO 10, 59 double
SET COLOR TO R/W

@  2, 38  SAY ROBS_
@  3, 20  SAY ROBN_
@  4, 20  SAY DOBK_

SET COLOR TO N/W,R/W
@  5, 20  say replicate("",39)
SET COLOR TO N/W,W+/R
TONE(500,1)

set cursor on

@  7, 21  SAY "CENA    : " GET CENA_
@  7, 50  SAY "din."
@  9, 21  SAY "KOLICINA: " GET ZALI_
@  9, 50  SAY MERA_
READ
CLEAR GETS


  IF UPDATED()=.T.
     // OK
  ENDIF

COMMIT
tone(500,1)
set cursor off
SETCOLOR(boja)
RESTORE SCREEN FROM prozor
RELEASE prozor
RETURN(0)















/*
*
* Koristi se spisak artikala dok je aktivan-otvoren, za iznalazenje vrednosti
* zaliha (fakturne, nabavne, velikoprodajne i maloprodajne) po formuli zalihe
* puta cena.
*
*/
***********************************************************************************
FUNCTION Stanje_Zaliha(nn)
***********************************************************************************

      LOCAL VREDNOST := 0,  BROJ := RECCOUNT()
      GO TOP
      DO WHILE .NOT. EOF()
         VREDNOST := VREDNOST + (ZALI_ * CENA_)
         SKIP
      ENDDO
      GO TOP

     cTitle := "STANJE ZALIHA PO SPISKU ARTIKALA"
      cText := "Ukupno artikala "+str(broj,5) +chr(13)+;
               "Maloprodajna vrednost "+str(VREDNOST,18,2)

      MsgBox(cText,cTitle)

RETURN(0)



























